<template>
  <div>
    <b-card align="right">
      <b-button-group>
        <b-button variant="primary" @click="refreshMinions"
          >Refresh minions information</b-button
        >
        <b-button variant="outline-primary" @click="refresh"
          ><b-icon icon="arrow-clockwise" aria-hidden="true"></b-icon
        ></b-button>
      </b-button-group>
    </b-card>

    <b-table :items="items" :fields="fields">
      <template #cell(show_details)="row">
        <b-button :to="`/salt/minions/${row.item.minion_id}`">
          Details
        </b-button>
      </template>
    </b-table>
  </div>
</template>

<script>
import * as errors from '~/utils/errors.js'
import * as toast from '~/utils/toast.js'

export default {
  middleware: ['auth'],
  computed: {
    minions() {
      return this.$store.getters['salt/minions']
    },
    items() {
      // Hack to clone the minions to be able to modify them in the table
      return JSON.parse(JSON.stringify(Object.values(this.minions)))
    },
    fields() {
      return [
        { key: 'minion_id', sortable: true },
        { key: 'grains.image', label: 'Image', sortable: true },
        { key: 'grains.room', label: 'Room', sortable: true },
        { key: 'grains.site', label: 'Site', sortable: true },
        { key: 'grains.fqdn', label: 'FQDN', sortable: true },
        { key: 'grains.os', label: 'OS', sortable: true },
        { key: 'last_job', sortable: true },
        'show_details',
      ]
    },
  },
  mounted() {
    this.refresh(null)
  },
  methods: {
    async refresh(event) {
      await this.$store
        .dispatch('salt/getMinions')
        .catch(errors.handleError(this))
    },

    async refreshMinions(event) {
      toast.toast(
        this,
        'Refreshing minions information',
        'Please wait a few seconds...',
        'info'
      )

      await this.$store
        .dispatch('salt/refreshMinions')
        .catch(errors.handleError(this))
      await this.refresh(null)

      toast.toast(this, 'Minions have been refreshed', ' ', 'success')
    },
  },
}
</script>
